﻿/**
 * ...
 * @author Georg Graf
 */

package com.georg;
import flash.display.Sprite;
import flash.events.Event;
import flash.events.KeyboardEvent;
import flash.events.MouseEvent;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.text.TextFieldType;

class Stepper extends Sprite
{
	private var text:TextField;
	private var up:Sprite;
	private var down:Sprite;
	
	private var _value:Int;
	public var value(getValue, setValue):Int;
	
	public function new(start:Int = 0) 
	{
		super();
		
		createText();
		createUp();
		createDown();
		
		value = start;
	}
	
	private function createText():Void
	{
		graphics.beginFill(0xf28729, .5);
		graphics.drawRect(0, 0, 44, 21);
		graphics.endFill();
		
		text = new TextField();
		text.type = TextFieldType.INPUT;
		text.defaultTextFormat = new TextFormat("Arial", 12, 0);
		text.width = 30;
		text.text = cast(value);
		text.x = 5;
		text.y = 1;
		text.addEventListener(KeyboardEvent.KEY_DOWN, enterPressed);
		addChild(text);
	}
	
	private function createUp():Void
	{
		up = new Sprite();
		up.graphics.beginFill(0xf28729);
		up.graphics.drawRect(0, 0, 14, 10);
		up.graphics.endFill();
		
		up.graphics.beginFill(0xffae00);
		up.graphics.moveTo(7, 2);
		up.graphics.lineTo(10, 8);
		up.graphics.lineTo(4, 8);
		up.graphics.lineTo(7, 2);
		up.graphics.endFill();
		
		up.buttonMode = true;
		up.x = 30;
		up.addEventListener(MouseEvent.CLICK, upClicked);
		addChild(up);
	}
	private function createDown():Void
	{
		down = new Sprite();
		down.graphics.beginFill(0xf28729);
		down.graphics.drawRect(0, 0, 14, 10);
		down.graphics.endFill();
		
		down.graphics.beginFill(0xffae00);
		down.graphics.moveTo(7, 8);
		down.graphics.lineTo(10, 2);
		down.graphics.lineTo(4, 2);
		down.graphics.lineTo(7, 8);
		down.graphics.endFill();
		
		down.buttonMode = true;
		down.x = 30;
		down.y = 11;
		down.addEventListener(MouseEvent.CLICK, downClicked);
		addChild(down);
	}
	
	private function upClicked(e:MouseEvent):Void { value++; }
	private function downClicked(e:MouseEvent):Void { value--; }
	private function enterPressed(e:KeyboardEvent):Void 
	{ 
		if (e.keyCode == 13)
		{
			var newVal:Int = Std.parseInt(text.text);
			
			if (newVal > 0)
				value = newVal; 
		}
	}

	
	private function getValue() { return _value; }
	private function setValue(v:Int)
	{
		if (v > 0) 
		{
			_value = v;
			text.text = cast(_value);
			
			dispatchEvent(new Event(Event.CHANGE));
		}
		return _value;
	}
}