﻿/**
 * ...
 * @author Georg Graf
 */

package com.georg.tools;

class ComplexNumber 
{
	public var re:Float;
	public var im:Float;
	
	public function new(re:Float, im:Float) 
	{
		this.re = re;
		this.im = im;
	}
	
	public function clone():ComplexNumber
	{
		return new ComplexNumber(re, im);
	}
	
	public function toString():String
	{
		return "(" + re + "; " + im + ")";
	}
	
	inline public function add( cn:ComplexNumber):ComplexNumber
	{
		return new ComplexNumber(this.re + cn.re, this.im + cn.im);
	}
	
	inline public function subtract(cn:ComplexNumber):ComplexNumber
	{
		return new ComplexNumber(this.re - cn.re, this.im - cn.im);
	}
	
	inline public function multiply(cn:ComplexNumber):ComplexNumber
	{
		return new ComplexNumber(	(this.re * cn.re - this.im * cn.im), 
									(this.re * cn.im + this.im * cn.re));
	}
	
	inline public function divide(cn:ComplexNumber):ComplexNumber
	{
		return new ComplexNumber(	(this.re * cn.re + this.im * cn.im) / (cn.re * cn.re + cn.im * cn.im), 
									(this.im * cn.re - this.re * cn.im) / (cn.re * cn.re + cn.im * cn.im));
	}
	
	inline public function power(level:Int = 2):ComplexNumber
	{
		var cn:ComplexNumber = clone();
		
		for (i in 1...level)
			cn = multiply(cn); 
			
		return cn;
	}
	
	inline public function abs():Float
	{
		return Math.sqrt(re * re + im * im);
	}
	
	inline public function phi():Float
	{
		return Math.asin(this.im / this.re);
	}
	
}