﻿/**
 * ...
 * @author Georg Graf
 */

package com.georg.tools;
import flash.display.MovieClip;
import flash.events.TimerEvent;
import flash.Lib;
import flash.text.TextField;
import flash.text.TextFormat;
import flash.events.Event;
import flash.utils.Timer;
 
class FPSCounter extends TextField
{
	// time save vars
	private var startTick:Float;
	private var tick:Float;
	// frame save vars
	private var numFrames:Float;
	private var frames:Float;
	// reset timer var
	private var timer:Timer;
	
	// calc vars
	private var startDiff:Float;
	private var diff:Float;
  
	public function new()
	{
		super();
		
		timer = new Timer(1000, 0);
		timer.addEventListener(TimerEvent.TIMER, resetFrames);
		
		defaultTextFormat = new TextFormat("Arial", 12, 0xFFFFFF);
		mouseEnabled = false;
	}
	
	private function resetFrames(e:TimerEvent):Void 
	{
		// reset only current fps
		startTick  = Lib.getTimer();
		frames = 0;
	}
	
	public function start():Void 
	{ 
		numFrames = 0;
		frames = 0;
		startTick  = Lib.getTimer();
		tick  = Lib.getTimer();
		timer.start();
		addEventListener(Event.ENTER_FRAME, onEnterFrame); 
	}
		
	public function stop():Void 
	{ 
		removeEventListener(Event.ENTER_FRAME, onEnterFrame); 
		timer.stop();
	} 
  
	public function onEnterFrame(event:Event):Void
	{
		++numFrames;
		++frames;
		
		startDiff = (Lib.getTimer() - startTick) * .001;
		diff = (Lib.getTimer() - tick) * .001;
		
		text = Math.floor(frames / startDiff) + " FPS " + Math.floor(numFrames / diff) + " AV";
	}
 }